/* 2008.10.18
****************************************
**  Copyright  (C)  W.ch  1999-2009   **
**  Web:  http://www.winchiphead.com  **
****************************************
**  USB Host File Interface for CH376 **
**  TC2.0@PC, KC7.0@MCS51             **
****************************************
*/
/* CH376 ļϵͳӿ */

/* MCS-51ƬCԵUļдʾ */
/* ʾֽڶд,ļö, ڽUе/C51/CH376HFT.Cļеǰ200ַʾ,
   ҲԭļCH376HFT.C, ôóʾC51Ŀ¼CH376ͷļ,
   ҲC51Ŀ¼, ôóʾĿ¼µļ */

#include "CH376.H"

#include "..\HAL.H"
#include "..\HAL_BASE.C"
#include "..\DEBUG.H"
#include "..\DEBUG.C"
#include "..\PARA_HW.C"		/* Ӳ߲ӷʽ */
//#include "..\PARA_SW.C"		/* ģⲢӷʽ */
//#include "..\SPI_HW.C"		/* ӲSPIӷʽ */
//#include "..\SPI_SW.C"		/* ģSPIʽ */
//#include "..\UART_HW.C"		/* Ӳ첽ӷʽ */
#include "..\FILE_SYS.H"
#include "..\FILE_SYS.C"

UINT8		idata	buf[64];

void	host( ) {
	UINT8	i, s;
	UINT8	TotalCount;
	UINT16	RealCount;
	P_FAT_DIR_INFO	pDir;

	s = mInitCH376Host( );  /* ʼCH376 */
	mStopIfError( s );
/* ·ʼ */

	while ( 1 ) {
		printf( "Wait Udisk/SD\n" );
		while ( CH376DiskConnect( ) != USB_INT_SUCCESS ) {  /* UǷ,ȴU̲,SD,ɵƬֱӲѯSDĲ״̬ */
			if ( IsKeyPress( ) ) {  /* м */
				printf( "Exit USB host mode\n" );
				return;
			}
			mDelaymS( 100 );  /* ûҪƵѯ */
		}
		LED_UDISK_IN( );  /* LED */
		mDelaymS( 200 );  /* ʱ,ѡ,еUSB洢Ҫʮʱ */

/* ڼ⵽USB豸,ȴ100*50mS,ҪЩMP3̫,ڼ⵽USB豸DISK_MOUNTED,ȴ5*50mS,ҪDiskReady */
		for ( i = 0; i < 100; i ++ ) {  /* ȴʱ,100*50mS */
			mDelaymS( 50 );
			printf( "Ready ?\n" );
			s = CH376DiskMount( );  /* ʼ̲ԴǷ */
			if ( s == USB_INT_SUCCESS ) break;  /* ׼ */
			else if ( s == ERR_DISK_DISCON ) break;  /* ⵽Ͽ,¼Ⲣʱ */
			if ( CH376GetDiskStatus( ) >= DEF_DISK_MOUNTED && i >= 5 ) break;  /* еUǷδ׼,Ժ,ֻҪ佨MOUNTEDҳ5*50mS */
		}
		if ( s == ERR_DISK_DISCON ) {  /* ⵽Ͽ,¼Ⲣʱ */
			printf( "Device gone\n" );
			continue;
		}
		if ( CH376GetDiskStatus( ) < DEF_DISK_MOUNTED ) {  /* δ֪USB豸,USB̡ӡ */
			printf( "Unknown device\n" );
			goto UnknownUsbDevice;
		}
		i = CH376ReadBlock( buf );  /* Ҫ,ԶȡݿCH376_CMD_DATA.DiskMountInq,س */
		if ( i == sizeof( INQUIRY_DATA ) ) {  /* U̵ĳ̺ͲƷϢ */
			buf[ i ] = 0;
			printf( "UdiskInfo: %s\n", ((P_INQUIRY_DATA)buf) -> VendorIdStr );
		}

/* ȡԭļ */
		printf( "Open\n" );
		strcpy( buf, "\\C51\\CH376HFT.C" );  /* Դļ,༶Ŀ¼µļ·븴ƵRAMٴ,Ŀ¼ߵǰĿ¼µļRAMROM */
		s = CH376FileOpenPath( buf );  /* ļ,ļC51Ŀ¼ */
		if ( s == ERR_MISS_DIR || s == ERR_MISS_FILE ) {  /* ûҵĿ¼ûҵļ */
/* гļ,öٿԲοEXAM13ȫö */
			if ( s == ERR_MISS_DIR ) strcpy( buf, "\\*" );  /* C51Ŀ¼гĿ¼µļ */
			else strcpy( buf, "\\C51\\CH376*" );  /* CH376HFT.Cļг\C51Ŀ¼µCH376ͷļ */
			printf( "List file %s\n", buf );
			s = CH376FileOpenPath( buf );  /* öٶ༶Ŀ¼µļĿ¼,뻺RAM */
			while ( s == USB_INT_DISK_READ ) {  /* öٵƥļ */
				CH376ReadBlock( buf );  /* ȡöٵļFAT_DIR_INFOṹ,سsizeof( FAT_DIR_INFO ) */
				pDir = (P_FAT_DIR_INFO)buf;  /* ǰļĿ¼Ϣ */
				if ( pDir -> DIR_Name[0] != '.' ) {  /* ǱϼĿ¼,붪 */
					if ( pDir -> DIR_Name[0] == 0x05 ) pDir -> DIR_Name[0] = 0xE5;  /* ַ滻 */
					pDir -> DIR_Attr = 0;  /* ǿļַԱӡ */
					printf( "*** EnumName: %s\n", pDir -> DIR_Name );  /* ӡ,ԭʼ8+3ʽ,δɺСָ */
				}
				xWriteCH376Cmd( CMD0H_FILE_ENUM_GO );  /* öļĿ¼ */
				xEndCH376Cmd( );
				s = Wait376Interrupt( );
			}
			if ( s != ERR_MISS_FILE ) mStopIfError( s );  /*  */
		}
		else {  /* ҵļ߳ */
			mStopIfError( s );
			TotalCount = 200;  /* ׼ȡܳ */
			printf( "ļжǰ%dַ:\n",(UINT16)TotalCount );
			while ( TotalCount ) {  /* ļȽϴ,һζ,ٵCH376ByteReadȡ,ļָԶƶ */
				if ( TotalCount > sizeof(buf) ) i = sizeof(buf);  /* ʣݽ϶,ƵζдĳȲܳС */
				else i = TotalCount;  /* ʣֽ */
				s = CH376ByteRead( buf, i, &RealCount );  /* ֽΪλȡݿ,ζдĳȲܳС,ڶεʱŸղŵ */
				mStopIfError( s );
				TotalCount -= (UINT8)RealCount;  /* ,ȥǰʵѾַ */
				for ( s=0; s!=RealCount; s++ ) printf( "%C", buf[s] );  /* ʾַ */
				if ( RealCount < i ) {  /* ʵʶַҪַ,˵ѾļĽβ */
					printf( "\n" );
					printf( "ļѾ\n" );
					break;
				}
			}
			printf( "Close\n" );
			s = CH376FileClose( FALSE );  /* رļ */
			mStopIfError( s );
		}

UnknownUsbDevice:
		printf( "Take out\n" );
		while ( CH376DiskConnect( ) == USB_INT_SUCCESS ) {  /* UǷ,ȴṴγ */
			mDelaymS( 100 );
		}
		LED_UDISK_OUT( );  /* LED */
		mDelaymS( 100 );
	}
}
