/* 2008.10.18
****************************************
**  Copyright  (C)  W.ch  1999-2009   **
**  Web:  http://www.winchiphead.com  **
****************************************
**  USB Host File Interface for CH376 **
**  TC2.0@PC, KC7.0@MCS51             **
****************************************
*/
/* CH376 ļϵͳӿ */

/* MCS-51ƬCԵUļдʾ */
/* ʾUǷд,ʾģ˵İȫƳ,ҲԲοд */

/* C51   CH376HFT.C */
/* LX51  CH376HFT.OBJ */
/* OHX51 CH376HFT */

#include <reg52.h>
#include <stdio.h>
#include <string.h>

#include "..\HAL.H"
#include "..\HAL_BASE.C"
#include "..\DEBUG.H"
#include "..\DEBUG.C"
#include "..\PARA_HW.C"		/* Ӳ߲ӷʽ */
//#include "..\PARA_SW.C"		/* ģⲢӷʽ */
//#include "..\SPI_HW.C"		/* ӲSPIӷʽ */
//#include "..\SPI_SW.C"		/* ģSPIʽ */
//#include "..\UART_HW.C"		/* Ӳ첽ӷʽ */
#include "..\FILE_SYS.H"
#include "..\FILE_SYS.C"

UINT8		idata	buf[64];

/* UǷд, USB_INT_SUCCESS˵д,0xFF˵ֻ/д,ֵ˵Ǵ */
/* BulkOnlyЭԲοӴ,޸ǰ˽USB MassStorageSCSI淶 */
UINT8	IsDiskWriteProtect( void )
{
	UINT8			s, SysBaseInfo;
	P_BULK_ONLY_CBW	pCbw;
	SysBaseInfo = CH376ReadVar8( VAR_SYS_BASE_INFO );  /* ǰϵͳĻϢ */
	pCbw = (P_BULK_ONLY_CBW)buf;
	for ( s = 0; s != sizeof( pCbw -> CBW_CB_Buf ); s ++ ) pCbw -> CBW_CB_Buf[ s ] = 0;  /* Ĭ0 */
	pCbw -> CBW_DataLen0 = 0x10;  /* ݴ䳤 */
	pCbw -> CBW_Flag = 0x80;  /* ䷽Ϊ */
	if ( SysBaseInfo & 0x40 ) {  /* SubClass-Code6 */
		pCbw -> CBW_CB_Len = 10;  /* ĳ */
		pCbw -> CBW_CB_Buf[0] = 0x5A;  /* ֽ, MODE SENSE(10) */
		pCbw -> CBW_CB_Buf[2] = 0x3F;
		pCbw -> CBW_CB_Buf[8] = 0x10;
	}
	else {  /* SubClass-CodeΪ6 */
		pCbw -> CBW_CB_Len = 6;  /* ĳ */
		pCbw -> CBW_CB_Buf[0] = 0x1A;  /* ֽ, MODE SENSE(6) */
		pCbw -> CBW_CB_Buf[2] = 0x3F;
		pCbw -> CBW_CB_Buf[4] = 0x10;
	}
	CH376WriteHostBlock( (PUINT8)pCbw, sizeof( BULK_ONLY_CBW ) );  /* USB˵ķͻдݿ,ʣಿCH376Զ */
	s = CH376SendCmdWaitInt( CMD0H_DISK_BOC_CMD );  /* UִBulkOnlyЭ */
	if ( s == USB_INT_SUCCESS ) {
		s = CH376ReadBlock( buf );  /* ӵǰ˵Ľջȡݿ,س */
		if ( s > 3 ) {  /* MODE SENSEݵĳЧ */
			if ( SysBaseInfo & 0x40 ) s = buf[3];  /* MODE SENSE(10), device specific parameter */
			else s = buf[2];  /* MODE SENSE(6), device specific parameter */
			if ( s & 0x80 ) return( 0xFF );  /* Uд */
			else return( USB_INT_SUCCESS );  /* Uûд */
		}
		return( USB_INT_DISK_ERR );
	}
	CH376DiskReqSense( );  /* USB洢 */
	return( s );
}

/* ȫƳU, USB_INT_SUCCESS˵԰ȫƳ,˵ܰȫƳ,ֻǿƳ */
/* ڲU׼ûγUǰ, ֹûγU̶ʧ */
UINT8	SafeRemoveDisk( void )
{
	UINT8	i, s;
	for ( i = 0; i < 20; i ++ ) {  /* еUǷδ׼,Ա */
		mDelaymS( 50 );
		if ( CH376DiskMount( ) == USB_INT_SUCCESS ) break;  /* ѯǷ׼ */
	}
	mDelaymS( 5 );
	s = CH376SendCmdDatWaitInt( CMD1H_SET_CONFIG, 0 );  /* ȡ,ᵼºܶU̵LED */
	mDelaymS( 5 );
	if ( i < 20 && s == USB_INT_SUCCESS ) return( USB_INT_SUCCESS );  /* ɹ */
	else return( 0xFF );
/* ȡSOFᵼ¾U̵LED */
/* ˴ȡSOF, ô˶Ӧ, ڼ⵽U̲ӦٻָΪģʽ6ָSOF */
//	xWriteCH376Cmd( CMD11_SET_USB_MODE );  /* 豸USBģʽ */
//	xWriteCH376Data( 0x05 );  /* ֹͣSOF,⵽U̲ģʽ6ָSOF */
//	mDelaymS( 2 );
//	xReadCH376Data( );
//	xEndCH376Cmd( );
}

main( ) {
	UINT8	s;
	mDelaymS( 100 );  /* ʱ100 */
	mInitSTDIO( );  /* Ϊüͨڼʾ */
	printf( "Start\n" );

	s = mInitCH376Host( );  /* ʼCH376 */
	mStopIfError( s );
/* ·ʼ */

	while ( 1 ) {
		printf( "Wait Udisk\n" );

//		while ( CH376DiskConnect( ) != USB_INT_SUCCESS ) {  /* UǷ,ȴU̲,SD,ɵƬֱӲѯSDĲ״̬ */
//			mDelaymS( 100 );
//		}
		while ( 1 ) {  /* ǰеķͬ,˴ǵȵж֪ͨٲѯUSB豸 */
			if ( Query376Interrupt( ) ) {  /* ѯCH376ж(INT#Ϊ͵ƽ) */
				if ( CH376DiskConnect( ) == USB_INT_SUCCESS ) break;  /* USB豸 */
			}
			mDelaymS( 100 );
		}

		mDelaymS( 200 );  /* ʱ,ѡ,еUSB洢Ҫʮʱ */

/* ڼ⵽USB豸,ȴ10*50mS */
		for ( s = 0; s < 10; s ++ ) {  /* ȴʱ,10*50mS */
			mDelaymS( 50 );
			printf( "Ready ?\n" );
			if ( CH376DiskMount( ) == USB_INT_SUCCESS ) break;  /* ʼ̲ԴǷ */
		}
		s = CH376ReadBlock( buf );  /* Ҫ,ԶȡݿCH376_CMD_DATA.DiskMountInq,س */
		if ( s == sizeof( INQUIRY_DATA ) ) {  /* U̵ĳ̺ͲƷϢ */
			buf[ s ] = 0;
			printf( "UdiskInfo: %s\n", ((P_INQUIRY_DATA)buf) -> VendorIdStr );
		}

		printf( "Check Disk Write Protect ? ...\n" );
		s = IsDiskWriteProtect( );  /* UǷд, USB_INT_SUCCESS˵д,0xFF˵ֻ/д,ֵ˵Ǵ */
		if ( s != USB_INT_SUCCESS && s != 0xFF ) {  /* ʧ */
			printf( "Again ...\n" );
			mDelaymS( 100 );
			s = IsDiskWriteProtect( );  /* һ */
		}
		if ( s == USB_INT_SUCCESS ) {  /* д */
			printf( "... No !\n" );
			printf( "Create a File\n" );
			s = CH376FileCreate( "\\NEWFILE.TXT" );  /* ڸĿ¼½ļ,ļѾɾ½ */
			mStopIfError( s );
			buf[0] = 'O';
			buf[1] = 'K';
			s = CH376ByteWrite( buf, 2, NULL );  /* ļд */
			mStopIfError( s );
			printf( "Close\n" );
			s = CH376FileClose( TRUE );  /* Զļ */
			mStopIfError( s );
			if ( SafeRemoveDisk( ) == USB_INT_SUCCESS ) {  /* ȫƳU */
				printf( "Safe Remove !\n" );
			}
			else {
				printf( "Unsafe Remove !\n" );
			}
		}
		else if ( s == 0xFF ) {  /* д */
			printf( "... Yes !\n" );
		}
		else {
			mStopIfError( s );  /* ʾ */
		}

		printf( "Take out\n" );

//		while ( CH376DiskConnect( ) == USB_INT_SUCCESS ) {  /* UǷ,ȴṴγ */
//			mDelaymS( 100 );
//		}
		while ( 1 ) {  /* ǰеķͬ,˴ǵȵж֪ͨٲѯUSB豸 */
			if ( Query376Interrupt( ) ) {  /* ѯCH376ж(INT#Ϊ͵ƽ) */
				if ( CH376DiskConnect( ) != USB_INT_SUCCESS ) break;  /* USB豸Ͽ */
			}
			mDelaymS( 100 );
		}

		mDelaymS( 200 );

	}
}
